
[Code]
var
 sMyAppName : String;
 sMyCustomMessageCouldnotfindproinstalldir : String;
 
function getTextFromNode( Doc :Variant; XPATH :Variant ) :Variant;
begin
  try
    Result := doc.SelectSingleNode(XPATH).Text
    Log( 'getTextFromNode: Receiving "' + Result + '" from node.' );
  except
    Log( 'getTextFromNode: Error by reading "' + XPATH + '"');
    Result := '';
    Exit;
  end;
end;

{
  this function will return a complete node with
    child-nodes, grand-child-nodes, grand-grand-..., etc.
    ( if they exist )
}
function load_xml( Name :String; XPATH :String ) :Variant;
var
  doc :Variant;
begin
  Result := True;
  
  try
   { Creating DOM-Object and loading XML-File }
   doc := CreateOleObject('MSXML2.DOMDocument');
	 doc.setProperty('SelectionLanguage', 'XPath');
	 doc.async := False;
	 doc.load( Name );
	 Log( 'load_xml: loading "' + Name  + '"...');
	 if Doc.parseError.errorCode <> 0 then
	 begin
    RaiseException('load_xml: Error on line ' + IntToStr(doc.parseError.line) + ', position ' + IntToStr(doc.parseError.linepos) + ': ' + doc.parseError.reason);
	 	Result := '';
	 	Exit;
	 end;

	 { Returning complete node }
	 Log( 'load_xml: returning "' + XPATH + '".' );
   Result := Doc.documentElement.SelectSingleNode(XPATH);
  except
    Log('load_xml: unknown error.');
  end;
end;


function GetMyAppName(dummy: String): String;
begin
  Result := sMyAppName;
end;

function GetPROInstallDir(dummy: String): String;
var sRet: String;
begin
  if RegQueryStringValue(HKEY_LOCAL_MACHINE, 'Software\Issendorff\LCN-PRO_2012', 'InstallDir', sRet) then
  begin
    // Successfully read the value
    log ('res := ' + sRet);
    Result := sRet;
  end
  else
  begin
    //evtl. x64?
    if RegQueryStringValue(HKEY_LOCAL_MACHINE, 'Software\Wow6432Node\Issendorff\LCN-PRO_2012', 'InstallDir', sRet) then
    begin
      // Successfully read the value
    log ('res := ' + sRet);
      Result := sRet;
    end
    else
    begin
      //jetzt wirklich! fatal error, konnte installdir nicht auslesen!    
      log ('GetPROInstallDir failed --> Kein Pro drauf.');
      MsgBox(sMyCustomMessageCouldnotfindproinstalldir, mbCriticalError, MB_OK);
    end;  
  end;
end;

function InitializeSetup(): Boolean;
var
  Node :Variant;
  tmp : String;
  doc : Variant;
begin
  ExtractTemporaryFile('language.xml'); //erstmal entpacken ;)


  Node := load_xml( ExpandConstant('{tmp}') + '\language.xml', '/language' );
  doc := Node.OwnerDocument;
  sMyAppName := getTextFromNode( doc, '/language/title' );
  log('sMyAppName='+sMyAppName);
  
  sMyCustomMessageCouldnotfindproinstalldir := getTextFromNode( doc, '/language/CustomMessageCouldnotfindproinstalldir' );
  log('sMyCustomMessageCouldnotfindproinstalldir='+sMyCustomMessageCouldnotfindproinstalldir);

  if GetPROInstallDir('') = '' then
    begin
      Result:=false;
      Exit;
    end
    else
    begin
      Result:=True;
    end;
end;
